{$F+,A-,V-,X+,O-}

{$IFDEF DPMI}
{$C FIXED PRELOAD PERMANENT}
{$ENDIF}


{[]------------------------------------------------------------[]}
{|                                                              |}
{|  KEYBOARD.PAS      ࠩ                         |}
{|                                                              |}
{|                  o প  F11  F12                |}
{|                  o ४祭 ० /     |}
{|                    Ctrl, Alt, Shift, ࠧ  ⮬       |}
{|                    /ࠢ  稨 ७      |}
{|                                                    |}
{|                  o   ९  ० ᪮   |}
{|                     १ Alt/Shift+Alt            |}
{|                                                              |}
{|  Version 3.0       Copyright (c) 1994  SVsw                  |}
{|                                                              |}
{[]------------------------------------------------------------[]}

unit
  Keyboard;

interface

uses
  Dos;

type             { 䨣 ࠩ  }
  TKbdDrvCfg = record
    Language         : WordBool; { 몮 ० }
    CapsLock         : word;     {  ॣ }
    ClearScanCode    : word;     { ⪠ ᪠- }
    TriggerKey       : word;     { -४⥫ }
    PunctuationMarks : WordBool; {   Alt/Shift+Alt 
                                     ९  ᪮
                                   ०  }
    Active           : WordBool; {  ⨢ ࠩ }
  end;

const
  lnLatin      = False;  { 몮 ० }
  lnCyrillic   = True;

  clDefault    = 0;      {  ॣ }
  clUpper      = 1;
  clLower      = 2;

  scDefault    = 0;      { ⪠ ᪠- }
  scClearHigh  = 1;
  scClearAll   = 2;

  tkNone       = 0;      { -४⥫ }
  tkLeftCtrl   = 1;
  tkRightCtrl  = 2;
  tkLeftAlt    = 3;
  tkRightAlt   = 4;
  tkLeftShift  = 5;
  tkRightShift = 6;

const     {  䨣 ࠩ  }
  KbdDrvCfg : TKbdDrvCfg = (
    Language         : lnLatin;
    CapsLock         : clDefault;
    ClearScanCode    : scDefault;
    TriggerKey       : tkNone;
    PunctuationMarks : False;
    Active           : False
  );
                 {  ७  }
  EnhancedKeyboard : boolean = False;
                 { - ७  }
  kbF11 = $8500; kbShiftF11 = $8700; kbCtrlF11 = $8900;  kbAltF11 = $8B00;
  kbF12 = $8600; kbShiftF12 = $8800; kbCtrlF12 = $8A00;  kbAltF12 = $8C00;

procedure InitKeyboard;
procedure DoneKeyboard;

implementation

uses CharCase;

const        { ᪠- Ctrl, Alt  Shift' }
  scCtrl   = $1D;
  scAlt    = $38;
  scLShift = $2A;
  scRShift = $36;

type
  TTriggerKeyTable = record
    ScanCodeDn : byte;          { ᪠-  }
    ScanCodeUp : byte;          { ᪠- ⦠ }
    CheckPlace : boolean;       { ஢ /ࠢ? }
  end;

const
  TriggerKeyTable : array[tkNone..tkRightShift] of TTriggerKeyTable =
  { None }       ((ScanCodeDn : 0;
                   ScanCodeUp : 0;
                   CheckPlace : False),
  { left Ctrl }   (ScanCodeDn : scCtrl;
                   ScanCodeUp : scCtrl or $80;
                   CheckPlace : True),
  { right Ctrl }  (ScanCodeDn : scCtrl;
                   ScanCodeUp : scCtrl or $80;
                   CheckPlace : True),
  { left Alt }    (ScanCodeDn : scAlt;
                   ScanCodeUp : scAlt or $80;
                   CheckPlace : True),
  { right Alt }   (ScanCodeDn : scAlt;
                   ScanCodeUp : scAlt or $80;
                   CheckPlace : True),
  { left Shift }  (ScanCodeDn : scLShift;
                   ScanCodeUp : scLShift or $80;
                   CheckPlace : False),
  { right Shift } (ScanCodeDn : scRShift;
                   ScanCodeUp : scRShift or $80;
                   CheckPlace : False));

const            {  䨫樨 BIOS' ७  }
  FiltersEnhancedKeys : boolean = True;

const            { ࠭  INT 9h, INT 16h }
  SaveInt16H   : pointer = nil;
  SaveInt09H   : pointer = nil;
                 { 稪 ⨩ -४⥫ }
  TriggerKeyCount : longint = 0;

procedure NewInt09H; interrupt;
var
  ScanCode           : byte;
  IncTriggerKeyCount : boolean;
begin
  asm        {  ᪠- ⮩  }
         IN       AL, 60H
         MOV      ScanCode, AL
         PUSHF              {  BIOS ࠡ⠥  }
         CALL     DWORD PTR SaveInt09H
  end;
  with KbdDrvCfg do
    if Active then                       { ࠩ ⨢? }
      if TriggerKey <> tkNone then       { ४⥫ ࠭? }
        with TriggerKeyTable[TriggerKey] do
          if ScanCode = ScanCodeDn then  { ४⥫ ? }
            begin
              if not CheckPlace then     { ஢ /ࠢ? }
                Inc(TriggerKeyCount)
              else
                begin
                  case TriggerKey of
                    tkLeftCtrl :
                      IncTriggerKeyCount := Mem[Seg0040:$0018] and $01 <> 0;
                    tkLeftAlt  :
                      IncTriggerKeyCount := Mem[Seg0040:$0018] and $02 <> 0;
                    tkRightCtrl :
                      IncTriggerKeyCount := (Mem[Seg0040:$0017] and $04 <> 0)
                                            and
                                            (Mem[Seg0040:$0018] and $01 = 0);
                    tkRightAlt  :
                      IncTriggerKeyCount := (Mem[Seg0040:$0017] and $08 <> 0)
                                            and
                                            (Mem[Seg0040:$0018] and $02 = 0);
                  end;
                  if IncTriggerKeyCount then Inc(TriggerKeyCount);
                end;
            end
          else
            if ScanCode = ScanCodeUp then     { ४⥫ 饭? }
              begin  { ⠭ 몮 ० ,
                       ᫨ ४⥫   ࠧ }
                if TriggerKeyCount = 1 then Language := not Language;
                TriggerKeyCount := 0;  { 뢠 稪 ४祭 }
              end;
end;

const            { ᪫  }
  TableSize = 63;
  Cyrillic : array[0..TableSize] of char =   { ᪠ }
  '㪥뢠஫ᬨ';
  Latin : array[0..TableSize] of char =      { ⨭᪠ }
  'QWERTYUIOP{}ASDFGHJKL:"ZXCVBNM<>qwertyuiop[]asdfghjkl;''zxcvbnm,.';

procedure Cyrillic2Latin; near; assembler;
   {  ਫ   }
asm
        MOV     CX,DS                   {    ⠡ Cyrillic }
        MOV     ES,CX
        MOV     DI,OFFSET Cyrillic
        MOV     CX,TableSize + 2
        CLD
        REPNE   SCASB
        JCXZ    @@1                     {  ... }
        SUB     DI,OFFSET Cyrillic - 1  {     ⠡ Latin }
        MOV     SI,OFFSET Latin - 2
        ADD     SI,DI
        LODSB
@@1:
end;

procedure Latin2Cyrillic; near; assembler;
   {  뭨  ਫ }
asm
        MOV     CX,DS                   {    ⠡ Latin }
        MOV     ES,CX
        MOV     DI,OFFSET Latin
        MOV     CX,TableSize + 2
        CLD
        REPNE   SCASB
        JCXZ    @@1                     {  ... }
        SUB     DI,OFFSET Latin - 1     {     ⠡ Cyrillic }
        MOV     SI,OFFSET Cyrillic - 2
        ADD     SI,DI
        LODSB
@@1:
end;

function ReplaceAltInput(Code : word) : word;
   {  Alt-   ९ }
const
  ScanCodeArray : array[0..5] of byte = ($33,$34,$27,$28,$1A,$1B);
  CharCodeArray : array[Boolean,0..5] of byte = (
    ($3C,$3E,$3A,$22,$7B,$7D),
    ($2C,$2E,$3B,$27,$5B,$5D)
  );
type
  TWordRec = record
    Lo, Hi : byte;
  end;
var
  i : word;
  WordRec : TWordRec absolute Code;
begin
  with KbdDrvCfg, WordRec do
    for i := 0 to 5 do
      if Hi = ScanCodeArray[i] then
        begin
          Lo := CharCodeArray[(Mem[$0040:$0017] and 3 = 0),i];
          if ClearScanCode = scClearAll then
            Hi := 0;
          Break;
        end;
  ReplaceAltInput := Code;
end;

var
  CheckZF : boolean;

const
  ZFMask = $0040;

procedure NewInt16H; interrupt;
   { ࠡ稪 INT 16H }
begin
  asm
        MOV     AX, [BP+16]                { ⠭ AX }
        OR      AH, AH                     {  ? }
        JE      @@1                        { ... }
        CMP     AH, 1                      { ஢ઠ ? }
        JE      @@2                        { ... }
        CMP	AH, 10H                    {  ७ ? }
        JE      @@1                        { ... }
        CMP     AH, 11H                    { ஢ઠ ७ ? }
        JE      @@2                        { ... }
        MOV     BX, WORD PTR SaveInt16H    { ᥭ  ⥪ SaveInt16H }
        MOV     AX, WORD PTR SaveInt16H[2] {  ⠭ AX  BX }
        XCHG    BX, [BP+14]
        XCHG    AX, [BP+16]
        MOV     SP, BP                     { ⠭ ॣ஢ }
        POP     BP
        POP     ES
        POP     DS
        POP     DI
        POP     SI
        POP     DX
        POP     CX
        RETF                             { 室  SaveInt16H }
@@1:
        MOV     CheckZF, False           { ZF    }
        JMP     @@3
@@2:
        MOV     CheckZF,True             { ZF   }
        OR      WORD PTR [BP+22], ZFMask { ⠭ ZF }
@@3:
        CMP     EnhancedKeyboard, False  { ७ ? }
        JNE     @@4                      { ... }
        CMP     FiltersEnhancedKeys, False { BIOS 䨫 ७ ? }
        JE      @@5                      { ... }
@@4:
        OR      AH, 10H                  {  ७  }
@@5:
        PUSHF                            { 맮 SaveInt16H }
        CALL    SaveInt16H
        PUSHF                            { Flags -> CX }
        POP     CX
        CMP     CheckZF, False           { ZF   ? }
        JE      @@6                      { ... }
        PUSH    CX                       {  ZF }
        POPF
        JZ      @@6
        AND     WORD PTR [BP+22], not ZFMask
@@6:
        CMP     AL, 0E0H                 { ७ ? }
        JNE     @@7                      { ...}
        OR      AH, AH                   { ୠ⨢ ? }
        JE      @@7                      { ...}
        CMP     AH, 23H                  {  ᪠ ""?}
        JE      @@7                      { ... }
        XOR     AL, AL                   { ⪠ ᪠- }
@@7:
        CMP     KbdDrvCfg.Active, False  { ࠩ ⨢? }
        JE      @@14                     { ... }
        CMP     AL, 20H                  { ७/ࠢ騩 ? }
        JBE     @@11                     { ... }
        CMP     KbdDRvCfg.Language, lnCyrillic { ? }
        JNE     @@8                      { ... }
        CALL    Latin2Cyrillic           { ८ࠧ   }
        JMP     @@9
@@8:
        CALL    Cyrillic2Latin           { ८ࠧ   }
@@9:
        CMP     KbdDrvCfg.CapsLock, clDefault { 㦭 ८ࠧ /? }
        JE      @@11                     { ... }
        PUSH    AX
        CMP     KbdDrvCfg.CapsLock, clUpper { ? }
        JNE     @@10                      { ... }
        CALL    UpCase                    { ८ࠧ   }
        JMP     @@11
@@10:
        CALL    LoCase                    { ८ࠧ   }
@@11:
        OR      AL,AL                     { ७ ? }
        JNE     @@12                      { ... }
        CMP     KbdDrvCfg.Language, lnCyrillic { ? }
        JNE     @@14                      { ... }
        CMP     KbdDrvCfg.PunctuationMarks, True    {  ࠧ襭? }
        JNE     @@14                      { ... }
        PUSH    AX                        {    ९ }
        CALL    ReplaceAltInput
        JMP     @@14
@@12:
        OR      AH,AH                     { ୠ⨢ ? }
        JE      @@14                      { ... }
        CMP     KbdDrvCfg.ClearScanCode, scDefault { 㦭 ⪠ ᪠-? }
        JE      @@14                      { ... }
        CMP     KbdDrvCfg.ClearScanCode, scClearAll {  ᪠-  ? }
        JE      @@13                      { ... }
        CMP     AL, 80H                   {    ⠡? }
        JB      @@14                      { ... }
@@13:
        XOR     AH,AH                    { ⪠ ᪠- }
@@14:
        MOV     [BP+16],AX               {  AX }
  end;
end;

procedure InitKeyboard;
begin
  if SaveInt16H = nil then
    begin
      GetIntVec($09, SaveInt09h);
      GetIntVec($16, SaveInt16h);
      SetIntVec($09, @NewInt09h);
      SetIntVec($16, @NewInt16h);
    end;
end;

procedure DoneKeyboard;
begin
  if SaveInt16H <> nil then
    begin
      SetIntVec($09, SaveInt09h);
      SetIntVec($16, SaveInt16h);
   end;
end;

const
  SaveExitProc : pointer = nil;

procedure KeyboardExit;
begin
  ExitProc := SaveExitProc;
  DoneKeyboard;
end;

begin
  asm     { ஢ઠ ७  }
	MOV	AX, Seg0040             { ᫨ 4-     }
	MOV	ES,AX                   { 0040H:0069H ⠭,  }
	MOV	DI,96h                  {  ७  }
	TEST	BYTE PTR ES:[DI],00010000B
	JZ	@@1
	MOV     EnhancedKeyboard,True
@@1:
           { ஢ઠ 䨫樨 BIOS' ७  }
	PUSH	DS
	MOV	AX, Seg0040
	MOV	DS,AX
	CLI
	MOV	BX,DS:[80H]            {   F11 }
	MOV	DS:[1AH],BX
	MOV	WORD PTR [BX],kbF11
	ADD	BX,2
	MOV	DS:[1CH],BX
	STI
	MOV	AH,1			{ ஢ઠ ॠ樨 BIOS' }
	INT	16H
	MOV	AL,True
	JZ	@@2
        MOV     AL,False
	CLI
	MOV	DS:[1AH],BX
	MOV	DS:[1CH],BX
	STI
@@2:
	POP	DS
        MOV     FiltersEnhancedKeys,AL
  end;
  if not EnhancedKeyboard then
    begin
      TriggerKeyTable[tkLeftCtrl ].CheckPlace := False;
      TriggerKeyTable[tkRightCtrl].CheckPlace := False;
      TriggerKeyTable[tkLeftAlt  ].CheckPlace := False;
      TriggerKeyTable[tkRightAlt ].CheckPlace := False;
    end;
  SaveExitProc := ExitProc;
  ExitProc := @KeyboardExit;
end.  { End of file KEYBOARD.PAS}